IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
          WHERE
            O.NAME = 'ATUALIZA_PARAMPEDIDO_PDR' AND
            TYPE = 'P'                  AND
            U.UID = O.UID               AND
            U.NAME = USER)
   DROP PROCEDURE ATUALIZA_PARAMPEDIDO_PDR
GO

CREATE
PROCEDURE ATUALIZA_PARAMPEDIDO_PDR
   @P_CDFILIAL   VARCHAR(4)
AS
   DECLARE @V_UPDATE_TEXT             NVARCHAR(4000);
   DECLARE @V_INSERT_TEXT             NVARCHAR(4000);  
   DECLARE @V_IDCTRLVENEXP_PADRAO     VARCHAR(1);
   DECLARE @V_CDGRUPO_OPERADOR        VARCHAR(2);
   DECLARE @V_NRAUTGRUPOP             VARCHAR(3);
   DECLARE @V_CDFILIALREL             VARCHAR(4);
   DECLARE @V_CDFILIAL_OPERADOR       VARCHAR(4);
   DECLARE @V_CDFILIAL_PADRAO         VARCHAR(4);
   DECLARE @V_CDFILIAL                VARCHAR(4);
   DECLARE @V_NAME                    VARCHAR(50);
   DECLARE @V_CTFILIAL_PAREXP         INTEGER;
   DECLARE @V_CTFILIAL_OPERADOR       INTEGER;
   DECLARE @V_CTGRUPO_OPERADOR        INTEGER;
   DECLARE @V_CTIDCTRLVENEXP_PADRAO   INTEGER;
BEGIN
   BEGIN TRANSACTION;
   SELECT @V_CDFILIAL_PADRAO = MAX(CDFILIPADRAO)
   FROM PARAMGERAL;
   /*VERIFICA SE EXISTE FILIAL PADRAO PARAMETRIZADA*/
   IF (@V_CDFILIAL_PADRAO) IS NOT NULL BEGIN      
      /*VERIFICA SE EXISTE GRUPO DE OPERADOR PARA ATUALIZAR O PRAMETRO "Grupo com Autorizao para Atualizar Preo de Venda"*/     
         SELECT @V_CTGRUPO_OPERADOR = COUNT(*)
           FROM AUTGRUPOP
          WHERE IDAUTGRUPOP = 'ATPR'
            AND CDFILIAL = @V_CDFILIAL_PADRAO;   
         
         IF @V_CTGRUPO_OPERADOR > 0 BEGIN
            SELECT @V_CDGRUPO_OPERADOR = CDGRUPOPER
              FROM AUTGRUPOP
             WHERE IDAUTGRUPOP = 'ATPR'
               AND CDFILIAL = @V_CDFILIAL_PADRAO;
         END ELSE BEGIN
            SET @V_CDGRUPO_OPERADOR = NULL;
         END;
         
      /*VERIFICA SE EXISTE COMISSO DO VENDEDOR PARA A FILIAL PADRO*/
     
         SELECT @V_CTIDCTRLVENEXP_PADRAO = COUNT(*)
           FROM PAREXPEDICAO           
          WHERE CDFILIAL = @V_CDFILIAL_PADRAO;
     
        IF @V_CTIDCTRLVENEXP_PADRAO > 0 BEGIN
            SELECT @V_IDCTRLVENEXP_PADRAO = IDCTRLVENEXP 
              FROM PAREXPEDICAO           
             WHERE CDFILIAL = @V_CDFILIAL_PADRAO;
        END ELSE BEGIN 
            SET @V_IDCTRLVENEXP_PADRAO = NULL;     
        END; 
          
      /*SELECIONA TODAS AS FILIAIS QUE UTILIZAM A PARAMETRIZAO POR FILIAL PADRAO DA TABELA 'PARAMPEDIDO'*/      
      DECLARE C_INSPARAMPED CURSOR FOR
         (SELECT CDFILIAL
            FROM PARAMFILIPADR
           WHERE IDTABPARAMFILI = 'S'
             AND NMTABPARAMFILI = 'PARAMPEDIDO'
             AND CDFILIAL <> @V_CDFILIAL_PADRAO
             AND CDFILIAL = ISNULL(@P_CDFILIAL, CDFILIAL));
      OPEN C_INSPARAMPED;
      FETCH NEXT FROM C_INSPARAMPED INTO @V_CDFILIAL

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SET @V_UPDATE_TEXT = 'INSERT INTO PARAMPEDIDO (';
         SET @V_INSERT_TEXT = '(SELECT ';

         /*SELECIONA OS NOMES DAS COLUNAS DAS TABELA 'PARAMPEDIDO'*/

         DECLARE C_CAMPO CURSOR FOR (SELECT C.NAME
                                       FROM SYSOBJECTS O, SYSCOLUMNS C
                                      WHERE O.ID = C.ID
                                        AND O.NAME = 'PARAMPEDIDO'
                                        AND C.NAME <> 'CDFILIAL')
         OPEN C_CAMPO;
         FETCH NEXT FROM C_CAMPO INTO
            @V_NAME
         WHILE (@@FETCH_STATUS = 0) BEGIN
            SET @V_UPDATE_TEXT = @V_UPDATE_TEXT +@V_NAME+  ', ';
            SET @V_INSERT_TEXT = @V_INSERT_TEXT +@V_NAME+  ', ';
            FETCH NEXT FROM C_CAMPO INTO @V_NAME
         END;
         CLOSE C_CAMPO;
         DEALLOCATE C_CAMPO;
         /*DELETA A OS PARAMETROS DA FILIAL QUE UTILIZA PARAMETRIZAO PELA PADRO*/
         DELETE FROM PARAMPEDIDO
         WHERE CDFILIAL = @V_CDFILIAL;

         SET @V_UPDATE_TEXT = @V_UPDATE_TEXT+ 'CDFILIAL) ';
         SET @V_INSERT_TEXT = @V_INSERT_TEXT+ '''' +@V_CDFILIAL+''''+' ';

         SET @V_INSERT_TEXT = @V_INSERT_TEXT + 'FROM PARAMPEDIDO ';
         SET @V_INSERT_TEXT = @V_INSERT_TEXT + 'WHERE CDFILIAL = '+'''' +@V_CDFILIAL_PADRAO+ '''' + ')';
         SET @V_UPDATE_TEXT = @V_UPDATE_TEXT + @V_INSERT_TEXT;

         EXECUTE SP_EXECUTESQL @V_UPDATE_TEXT;
            
         /*ATUALIZA COMISSAO DO VENDEDOR NAS FILIAIS QUE UTILIZAM PARAMETRIZAO PELA FILIAL PADRAO*/
         IF @V_IDCTRLVENEXP_PADRAO IS NOT NULL BEGIN
            SELECT @V_CTFILIAL_PAREXP = COUNT(*) 
              FROM PAREXPEDICAO
             WHERE CDFILIAL = @V_CDFILIAL;
            IF @V_CTFILIAL_PAREXP > 0 BEGIN
               UPDATE PAREXPEDICAO
                  SET IDCTRLVENEXP = @V_IDCTRLVENEXP_PADRAO                   
                WHERE CDFILIAL     = @V_CDFILIAL;
            END ELSE BEGIN 
               INSERT INTO PAREXPEDICAO
               (IDCTRLVENEXP, CDFILIAL)
               VALUES
               (@V_IDCTRLVENEXP_PADRAO, @V_CDFILIAL);
            END;
         END;                
      
         IF @V_CDGRUPO_OPERADOR IS NOT NULL BEGIN            
               SELECT @V_CTFILIAL_OPERADOR = COUNT(*) 
                 FROM AUTGRUPOP
                WHERE IDAUTGRUPOP = 'ATPR'
                  AND CDFILIAL = @V_CDFILIAL;          
                 
            IF @V_CTFILIAL_OPERADOR > 0 BEGIN     
               SELECT @V_CDFILIAL_OPERADOR = CDFILIAL 
                 FROM AUTGRUPOP
                WHERE IDAUTGRUPOP = 'ATPR'
                  AND CDFILIAL = @V_CDFILIAL;
            END ELSE BEGIN  
               SET @V_CDFILIAL_OPERADOR = NULL;
            END;
          
            IF @V_CDFILIAL_OPERADOR IS NOT NULL BEGIN 
              UPDATE  AUTGRUPOP
                 SET  CDGRUPOPER = @V_CDGRUPO_OPERADOR 
               WHERE  CDFILIAL   = @V_CDFILIAL_OPERADOR
                 AND  IDAUTGRUPOP = 'ATPR';             
            END ELSE BEGIN             
              SELECT @V_NRAUTGRUPOP = MAX(NRAUTGRUPOP)
                FROM AUTGRUPOP
               WHERE (IDAUTGRUPOP = 'ATPR');
                 
               IF @V_NRAUTGRUPOP  IS NOT NULL BEGIN
                  SET @V_NRAUTGRUPOP = RIGHT(REPLICATE(0, 3)+(CONVERT(CHAR(3), (CONVERT(INT, @V_NRAUTGRUPOP)+1))), 3);
               END ELSE BEGIN 
                  SET @V_NRAUTGRUPOP = '000';
               END;
               INSERT INTO AUTGRUPOP
                  (CDGRUPOPER, CDFILIAL, IDAUTGRUPOP, NRAUTGRUPOP)
               VALUES
                  (@V_CDGRUPO_OPERADOR,  @V_CDFILIAL, 'ATPR', @V_NRAUTGRUPOP);              
             END;
          END ELSE BEGIN
             DELETE FROM AUTGRUPOP
              WHERE (IDAUTGRUPOP = 'ATPR')
                AND (CDFILIAL = @V_CDFILIAL);        
          END;
          FETCH NEXT FROM C_INSPARAMPED INTO  @V_CDFILIAL;
      END;      
      CLOSE C_INSPARAMPED;
      DEALLOCATE C_INSPARAMPED;
   END;
   COMMIT TRANSACTION;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_PARAMPEDIDO_PDR','5.07.006';
GO
